Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeCompiler.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeCompiler.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeCompiler.cs	(revision 3338)
@@ -36,5 +36,5 @@
       {typeof(Division), CodeSymbol.Div},
       {typeof(InvokeFunction), CodeSymbol.Call},
-      {typeof(Values), CodeSymbol.Values}
+      //{typeof(Values), CodeSymbol.Values}
     };
     private Dictionary<string, short> entryPoint = new Dictionary<string, short>();
@@ -50,5 +50,5 @@
                              select node;
       foreach (DefunTreeNode branch in functionBranches) {
-        entryPoint[branch.Name] = (short)code.Count;
+        entryPoint[branch.FunctionName] = (short)code.Count;
         code.AddRange(Compile(branch));
       }
@@ -65,5 +65,5 @@
           if (instr.symbol == CodeSymbol.Call) {
             var invokeNode = (InvokeFunctionTreeNode)node;
-            instr.iArg0 = entryPoint[invokeNode.InvokedFunctionName];
+            instr.iArg0 = entryPoint[invokeNode.Symbol.FunctionName];
           }
         } else {
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeCreator.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeCreator.cs	(revision 3338)
@@ -35,11 +35,33 @@
   [StorableClass]
   public abstract class SymbolicExpressionTreeCreator : SymbolicExpressionTreeOperator, ISolutionCreator {
+    private const string MaxFunctionDefinitionsParameterName = "MaxFunctionDefinitions";
+    private const string MaxFunctionArgumentsParameterName = "MaxFunctionArguments";
+    #region Parameter Properties
+    public IValueLookupParameter<IntValue> MaxFunctionDefinitionsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters[MaxFunctionDefinitionsParameterName]; }
+    }
+    public IValueLookupParameter<IntValue> MaxFunctionArgumentsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters[MaxFunctionArgumentsParameterName]; }
+    }
+    #endregion
+
+    #region Propeties
+    public IntValue MaxFunctionDefinitions {
+      get { return MaxFunctionDefinitionsParameter.ActualValue; }
+    }
+    public IntValue MaxFunctionArguments {
+      get { return MaxFunctionArgumentsParameter.ActualValue; }
+    }
+
+    #endregion
     protected SymbolicExpressionTreeCreator()
       : base() {
+      Parameters.Add(new ValueLookupParameter<IntValue>(MaxFunctionDefinitionsParameterName, "Maximal number of function definitions in the symbolic expression tree."));
+      Parameters.Add(new ValueLookupParameter<IntValue>(MaxFunctionArgumentsParameterName, "Maximal number of arguments of automatically defined functions in the symbolic expression tree."));
     }
 
     public sealed override IOperation Apply() {
-      SymbolicExpressionTreeParameter.ActualValue = Create(RandomParameter.ActualValue, SymbolicExpressionGrammarParameter.ActualValue,
-        MaxTreeSizeParameter.ActualValue, MaxTreeHeightParameter.ActualValue);
+      SymbolicExpressionTreeParameter.ActualValue = Create(Random, SymbolicExpressionGrammar,
+        MaxTreeSize, MaxTreeHeight, MaxFunctionDefinitions, MaxFunctionArguments);
 
       foreach (var node in SymbolicExpressionTreeParameter.ActualValue.IterateNodesPostfix()) {
@@ -49,5 +71,10 @@
     }
 
-    protected abstract SymbolicExpressionTree Create(IRandom random, ISymbolicExpressionGrammar grammar, IntValue maxTreeSize, IntValue maxTreeHeight);
+    protected abstract SymbolicExpressionTree Create(
+      IRandom random,
+      ISymbolicExpressionGrammar grammar,
+      IntValue maxTreeSize, IntValue maxTreeHeight,
+      IntValue maxFunctionDefinitions, IntValue maxFunctionArguments
+      );
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeCrossover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeCrossover.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeCrossover.cs	(revision 3338)
@@ -67,5 +67,4 @@
 
       IRandom random = RandomParameter.ActualValue;
-      ISymbolicExpressionGrammar grammar = SymbolicExpressionGrammarParameter.ActualValue;
 
       // randomly swap parents to remove a possible bias from selection (e.g. when using gender-specific selection)
@@ -77,5 +76,5 @@
 
       bool success;
-      SymbolicExpressionTree result = Cross(random, grammar, parent0, parent1,
+      SymbolicExpressionTree result = Cross(random, parent0, parent1,
         MaxTreeSizeParameter.ActualValue, MaxTreeHeightParameter.ActualValue, out success);
       
@@ -89,5 +88,5 @@
     }
 
-    protected abstract SymbolicExpressionTree Cross(IRandom random, ISymbolicExpressionGrammar grammar,
+    protected abstract SymbolicExpressionTree Cross(IRandom random, 
       SymbolicExpressionTree parent0, SymbolicExpressionTree parent1,
       IntValue maxTreeSize, IntValue maxTreeHeight, out bool success);
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeNode.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeNode.cs	(revision 3338)
@@ -38,8 +38,10 @@
     private Symbol symbol;
 
-    public SymbolicExpressionTreeNode() { }
+    public SymbolicExpressionTreeNode() {
+      subTrees = new List<SymbolicExpressionTreeNode>();
+    }
 
-    public SymbolicExpressionTreeNode(Symbol symbol) {
-      subTrees = new List<SymbolicExpressionTreeNode>();
+    public SymbolicExpressionTreeNode(Symbol symbol)
+      : this() {
       this.symbol = symbol;
     }
@@ -49,8 +51,8 @@
       symbol = original.symbol;
       subTrees = new List<SymbolicExpressionTreeNode>();
+      grammar = original.grammar;
       foreach (var subtree in original.SubTrees) {
-        AddSubTree((SymbolicExpressionTreeNode)subtree.Clone());
+        SubTrees.Add((SymbolicExpressionTreeNode)subtree.Clone());
       }
-      dynamicSymbols = new Dictionary<string, int>(original.dynamicSymbols);
     }
 
@@ -68,4 +70,14 @@
     }
 
+    private ISymbolicExpressionGrammar grammar;
+    public virtual ISymbolicExpressionGrammar Grammar {
+      get { return grammar; }
+      set {
+        grammar = value;
+        foreach (var subtree in subTrees)
+          subtree.Grammar = value;
+      }
+    }
+
     public int GetSize() {
       int size = 1;
@@ -80,46 +92,67 @@
     }
 
-    [Storable]
-    private Dictionary<string, int> dynamicSymbols = new Dictionary<string, int>();
-    public void AddDynamicSymbol(string symbolName) {
-      Debug.Assert(!dynamicSymbols.ContainsKey(symbolName));
-      dynamicSymbols[symbolName] = 0;
-    }
-
-    public void AddDynamicSymbol(string symbolName, int nArguments) {
-      AddDynamicSymbol(symbolName);
-      SetDynamicSymbolArgumentCount(symbolName, nArguments);
-    }
-
-    public void RemoveDynamicSymbol(string symbolName) {
-      dynamicSymbols.Remove(symbolName);
-    }
-
-    public IEnumerable<string> DynamicSymbols {
-      get { return dynamicSymbols.Keys; }
-    }
-
-    public int GetDynamicSymbolArgumentCount(string symbolName) {
-      return dynamicSymbols[symbolName];
-    }
-    public void SetDynamicSymbolArgumentCount(string symbolName, int nArguments) {
-      Debug.Assert(dynamicSymbols.ContainsKey(symbolName));
-      dynamicSymbols[symbolName] = nArguments;
-    }
-
     public virtual void ResetLocalParameters(IRandom random) { }
     public virtual void ShakeLocalParameters(IRandom random, double shakingFactor) { }
 
-    protected internal virtual void AddSubTree(SymbolicExpressionTreeNode tree) {
+    public virtual void AddSubTree(SymbolicExpressionTreeNode tree) {
       SubTrees.Add(tree);
+      //if (tree != null) 
+      tree.Grammar = Grammar;
     }
 
-    protected internal virtual void InsertSubTree(int index, SymbolicExpressionTreeNode tree) {
+    public virtual void InsertSubTree(int index, SymbolicExpressionTreeNode tree) {
       SubTrees.Insert(index, tree);
+      //if (tree != null) 
+      tree.Grammar = Grammar;
     }
 
-    protected internal virtual void RemoveSubTree(int index) {
+    public virtual void RemoveSubTree(int index) {
+      //if (SubTrees[index] != null)
+      SubTrees[index].Grammar = null;
       SubTrees.RemoveAt(index);
     }
+
+    public IEnumerable<SymbolicExpressionTreeNode> IterateNodesPrefix() {
+      yield return this;
+      foreach (var subtree in subTrees) {
+        foreach (var n in subtree.IterateNodesPrefix())
+          yield return n;
+      }
+    }
+
+    public IEnumerable<SymbolicExpressionTreeNode> IterateNodesPostfix() {
+      foreach (var subtree in subTrees) {
+        foreach (var n in subtree.IterateNodesPrefix())
+          yield return n;
+      }
+      yield return this;
+    }
+    //public int GetMinExpressionLength() {
+    //  return Grammar.GetMinExpressionLength(Symbol);
+    //}
+    //public int GetMaxExpressionLength() {
+    //  return Grammar.GetMaxExpressionLength(Symbol);
+    //}
+    //public int GetMinExpressionDepth() {
+    //  return Grammar.GetMinExpressionDepth(Symbol);
+    //}
+    public IEnumerable<Symbol> GetAllowedSymbols(int argumentIndex) {
+      return Grammar.Symbols.Where(s => Grammar.IsAllowedChild(Symbol, s, argumentIndex));
+    }
+    public int GetMinSubtreeCount() {
+      return Grammar.GetMinSubtreeCount(Symbol);
+    }
+    public int GetMaxSubtreeCount() {
+      return Grammar.GetMaxSubtreeCount(Symbol);
+    }
+    //public int GetMaxExpressionLength(Symbol s) {
+    //  return Grammar.GetMaxExpressionLength(s);
+    //}
+    //public int GetMinExpressionLength(Symbol s) {
+    //  return Grammar.GetMinExpressionLength(s);
+    //}
+    //public int GetMinExpressionDepth(Symbol s) {
+    //  return Grammar.GetMinExpressionDepth(s);
+    //}
 
     #region ICloneable Members
@@ -130,4 +163,19 @@
 
     #endregion
+
+
+    public bool IsValidTree() {
+      var matchingSymbol = (from symb in Grammar.Symbols
+                            where symb.Name == Symbol.Name
+                            select symb).SingleOrDefault();
+
+      if (SubTrees.Count < Grammar.GetMinSubtreeCount(matchingSymbol)) return false;
+      else if (SubTrees.Count > Grammar.GetMaxSubtreeCount(matchingSymbol)) return false;
+      else for (int i = 0; i < SubTrees.Count; i++) {
+          if (!GetAllowedSymbols(i).Select(x => x.Name).Contains(SubTrees[i].Symbol.Name)) return false;
+          if (!SubTrees[i].IsValidTree()) return false;
+        }
+      return true;
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeOperator.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeOperator.cs	(revision 3338)
@@ -45,4 +45,5 @@
     }
 
+    #region Parameter Properties
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters[RandomParameterName]; }
@@ -60,4 +61,23 @@
       get { return (ILookupParameter<ISymbolicExpressionGrammar>)Parameters[SymbolicExpressionGrammarParameterName]; }
     }
+    #endregion
+
+    #region Properties
+    public IRandom Random {
+      get { return RandomParameter.ActualValue; }
+    }
+    public SymbolicExpressionTree SymbolicExpressionTree {
+      get { return SymbolicExpressionTreeParameter.ActualValue; }
+    }
+    public IntValue MaxTreeSize {
+      get { return MaxTreeSizeParameter.ActualValue; }
+    }
+    public IntValue MaxTreeHeight {
+      get { return MaxTreeHeightParameter.ActualValue; }
+    }
+    public ISymbolicExpressionGrammar SymbolicExpressionGrammar {
+      get { return SymbolicExpressionGrammarParameter.ActualValue; }
+    }
+    #endregion
 
     protected SymbolicExpressionTreeOperator()
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeTerminalNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeTerminalNode.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeTerminalNode.cs	(revision 3338)
@@ -37,11 +37,11 @@
     }
 
-    protected internal override void AddSubTree(SymbolicExpressionTreeNode tree) {
+    public override void AddSubTree(SymbolicExpressionTreeNode tree) {
       throw new NotSupportedException();
     }
-    protected internal override void InsertSubTree(int index, SymbolicExpressionTreeNode tree) {
+    public override void InsertSubTree(int index, SymbolicExpressionTreeNode tree) {
       throw new NotSupportedException();
     }
-    protected internal override void RemoveSubTree(int index) {
+    public override void RemoveSubTree(int index) {
       throw new NotSupportedException();
     }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/Argument.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/Argument.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/Argument.cs	(revision 3338)
@@ -34,4 +34,16 @@
       }
     }
+
+    private int argumentIndex;
+    public int ArgumentIndex {
+      get { return argumentIndex; }
+    }
+
+    public Argument(int argumentIndex)
+      : base() {
+      this.argumentIndex = argumentIndex;
+      this.name = "ARG" + argumentIndex;
+    }
+
     public override SymbolicExpressionTreeNode CreateTreeNode() {
       return new ArgumentTreeNode(this);
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/ArgumentTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/ArgumentTreeNode.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/ArgumentTreeNode.cs	(revision 3338)
@@ -25,15 +25,16 @@
   [StorableClass]
   public sealed class ArgumentTreeNode : SymbolicExpressionTreeNode {
-    private int argumentIndex;
-    [Storable]
-    public int ArgumentIndex {
-      get { return argumentIndex; }
-      set { argumentIndex = value; }
+    public new Argument Symbol {
+      get { return (Argument)base.Symbol; }
+      set {
+        if (value == null) throw new ArgumentNullException();
+        if(!(value is Argument)) throw new ArgumentException();
+        base.Symbol = value; 
+      }
     }
-
+    
     // copy constructor
     private ArgumentTreeNode(ArgumentTreeNode original)
       : base(original) {
-      argumentIndex = original.argumentIndex;
     }
 
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/DefunTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/DefunTreeNode.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/DefunTreeNode.cs	(revision 3338)
@@ -22,4 +22,5 @@
 using System;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols {
   [StorableClass]
@@ -31,9 +32,13 @@
       set { numberOfArguments = value; }
     }
-    private string name;
+    private string functionName;
     [Storable]
-    public string Name {
-      get { return name; }
-      set { this.name = value; }
+    public string FunctionName {
+      get { return functionName; }
+      set { this.functionName = value; }
+    }
+
+    private new Defun Symbol {
+      get { return (Defun)base.Symbol; }
     }
 
@@ -41,9 +46,10 @@
     private DefunTreeNode(DefunTreeNode original)
       : base(original) {
-      name = original.Name;
+      functionName = original.functionName;
       numberOfArguments = original.numberOfArguments;
     }
 
     public DefunTreeNode(Defun defunSymbol) : base(defunSymbol) { }
+
 
     public override object Clone() {
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/InvokeFunction.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/InvokeFunction.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/InvokeFunction.cs	(revision 3338)
@@ -34,4 +34,12 @@
       }
     }
+    public string FunctionName { get; set; }
+
+    public InvokeFunction(string functionName)
+      : base() {
+      this.FunctionName = functionName;
+      this.name = "Invoke: " + functionName;
+    }
+
     public override SymbolicExpressionTreeNode CreateTreeNode() {
       return new InvokeFunctionTreeNode(this);
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/InvokeFunctionTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/InvokeFunctionTreeNode.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/InvokeFunctionTreeNode.cs	(revision 3338)
@@ -25,9 +25,6 @@
   [StorableClass]
   public sealed class InvokeFunctionTreeNode : SymbolicExpressionTreeNode {
-    private string invokedFunctionName;
-    [Storable]
-    public string InvokedFunctionName {
-      get { return invokedFunctionName; }
-      set { this.invokedFunctionName = value; }
+    public new InvokeFunction Symbol {
+      get { return (InvokeFunction)base.Symbol; }
     }
 
@@ -35,5 +32,4 @@
     private InvokeFunctionTreeNode(InvokeFunctionTreeNode original)
       : base(original) {
-      invokedFunctionName = original.invokedFunctionName;
     }
 
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/StartSymbol.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/StartSymbol.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/StartSymbol.cs	(revision 3338)
@@ -31,4 +31,8 @@
       }
     }
+
+    public override SymbolicExpressionTreeNode CreateTreeNode() {
+      return new StartSymbolTreeNode(this);
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/StartSymbolTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/StartSymbolTreeNode.cs	(revision 3338)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/StartSymbolTreeNode.cs	(revision 3338)
@@ -0,0 +1,38 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols {
+  [StorableClass]
+  public sealed class StartSymbolTreeNode : SymbolicExpressionTreeNode {
+    // copy constructor
+    private StartSymbolTreeNode(StartSymbolTreeNode original)
+      : base(original) {
+    }
+
+    public StartSymbolTreeNode(StartSymbol startSymbol) : base(startSymbol) { }
+
+    public override object Clone() {
+      return new StartSymbolTreeNode(this);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentCreaterTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentCreaterTest.cs	(revision 3338)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentCreaterTest.cs	(revision 3338)
@@ -0,0 +1,51 @@
+﻿using System;
+using System.Text;
+using System.Collections.Generic;
+using System.Linq;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Random;
+using System.Diagnostics;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ArchitectureAlteringOperators;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_3._3.Tests {
+  [TestClass]
+  public class ArgumentCreaterTest {
+    private const int POPULATION_SIZE = 1000;
+    private const int MAX_TREE_SIZE = 100;
+    private const int MAX_TREE_HEIGHT = 10;
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    [TestMethod()]
+    public void ArgumentCreaterDistributionsTest() {
+      var trees = new List<SymbolicExpressionTree>();
+      var grammar = Grammars.CreateArithmeticAndAdfGrammar();
+      var random = new MersenneTwister();
+      for (int i = 0; i < POPULATION_SIZE; i++) {
+        var tree = ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
+        ArgumentCreater.CreateNewArgument(random, tree, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
+        Assert.IsTrue(tree.IsValidExpression());
+        trees.Add(tree);
+      }
+      Assert.Inconclusive("ArgumentCreator: " + Environment.NewLine +
+        Util.GetSizeDistributionString(trees, 105, 5) + Environment.NewLine +
+        Util.GetFunctionDistributionString(trees) + Environment.NewLine +
+        Util.GetNumberOfSubTreesDistributionString(trees) + Environment.NewLine +
+        Util.GetTerminalDistributionString(trees) + Environment.NewLine
+        );
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentDeleterTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentDeleterTest.cs	(revision 3338)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentDeleterTest.cs	(revision 3338)
@@ -0,0 +1,51 @@
+﻿using System;
+using System.Text;
+using System.Collections.Generic;
+using System.Linq;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Random;
+using System.Diagnostics;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ArchitectureAlteringOperators;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_3._3.Tests {
+  [TestClass]
+  public class ArgumentDeleterTest {
+    private const int POPULATION_SIZE = 1000;
+    private const int MAX_TREE_SIZE = 100;
+    private const int MAX_TREE_HEIGHT = 10;
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    [TestMethod()]
+    public void ArgumentDeleterDistributionsTest() {
+      var trees = new List<SymbolicExpressionTree>();
+      var grammar = Grammars.CreateArithmeticAndAdfGrammar();
+      var random = new MersenneTwister();
+      for (int i = 0; i < POPULATION_SIZE; i++) {
+        var tree = ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
+        ArgumentDeleter.DeleteArgument(random, tree, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
+        Assert.IsTrue(tree.IsValidExpression());
+        trees.Add(tree);
+      }
+      Assert.Inconclusive("ArgumentDeleter: " + Environment.NewLine +
+        Util.GetSizeDistributionString(trees, 105, 5) + Environment.NewLine +
+        Util.GetFunctionDistributionString(trees) + Environment.NewLine +
+        Util.GetNumberOfSubTreesDistributionString(trees) + Environment.NewLine +
+        Util.GetTerminalDistributionString(trees) + Environment.NewLine
+        );
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/Grammars.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/Grammars.cs	(revision 3338)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/Grammars.cs	(revision 3338)
@@ -0,0 +1,77 @@
+﻿using System;
+using System.Text;
+using System.Collections.Generic;
+using System.Linq;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Random;
+using System.Diagnostics;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_3._3.Tests {
+  public static class Grammars {
+    private class Addition : Symbol { }
+    private class Subtraction : Symbol { }
+    private class Multiplication : Symbol { }
+    private class Division : Symbol { }
+    private class Terminal : Symbol { }
+
+    private class SimpleArithmeticGrammar : DefaultSymbolicExpressionGrammar {
+      public SimpleArithmeticGrammar()
+        : base() {
+        Initialize();
+      }
+
+      private void Initialize() {
+        var add = new Addition();
+        var sub = new Subtraction();
+        var mul = new Multiplication();
+        var div = new Division();
+        var terminal = new Terminal();
+
+        var allSymbols = new List<Symbol>() { add, sub, mul, div, terminal };
+        var functionSymbols = new List<Symbol>() { add, sub, mul, div };
+        foreach (var symb in allSymbols)
+          AddSymbol(symb);
+
+        foreach (var funSymb in functionSymbols) {
+          SetMinSubtreeCount(funSymb, 1);
+          SetMaxSubtreeCount(funSymb, 3);
+        }
+        SetMinSubtreeCount(terminal, 0);
+        SetMaxSubtreeCount(terminal, 0);
+
+        // allow each symbol as child of the start symbol
+        foreach (var symb in allSymbols) {
+          SetAllowedChild(StartSymbol, symb, 0);
+        }
+
+        // allow each symbol as child of every other symbol (except for terminals that have maxSubtreeCount == 0)
+        foreach (var parent in allSymbols) {
+          for (int i = 0; i < GetMaxSubtreeCount(parent); i++)
+            foreach (var child in allSymbols) {
+              SetAllowedChild(parent, child, i);
+            }
+        }
+      }
+    }
+
+    public static ISymbolicExpressionGrammar CreateSimpleArithmeticGrammar() {
+      var g = new GlobalSymbolicExpressionGrammar(new SimpleArithmeticGrammar());
+      g.MaxFunctionArguments = 0;
+      g.MinFunctionArguments = 0;
+      g.MaxFunctionDefinitions = 0;
+      g.MinFunctionDefinitions = 0;
+      return g;
+    }
+
+    public static ISymbolicExpressionGrammar CreateArithmeticAndAdfGrammar() {
+      var g = new GlobalSymbolicExpressionGrammar(new SimpleArithmeticGrammar());
+      g.MaxFunctionArguments = 3;
+      g.MinFunctionArguments = 0;
+      g.MaxFunctionDefinitions = 3;
+      g.MinFunctionDefinitions = 0;
+      return g;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.Tests.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.Tests.csproj	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.Tests.csproj	(revision 3338)
@@ -39,6 +39,11 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="SubroutineCreaterTest.cs" />
-    <Compile Include="SubtreeCrossoverTest.cs" />
+    <Compile Include="ArgumentCreaterTest.cs" />
+    <Compile Include="ArgumentDeleterTest.cs" />
+    <Compile Include="Grammars.cs" />
+    <Compile Include="SubtreeCrossoverTest.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="Util.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="ProbabilisticTreeCreaterTest.cs" />
